<?php
/***********************************************************************

  Copyright (C) 2002-2005  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


if ($pun_user['g_read_board'] == '0')
	message($lang_common['No view']);


$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 1)
	message($lang_common['Bad request']);

// Fetch some info about the post, the topic and the forum
$result = $db->query('SELECT f.id AS fid, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.id AS tid, t.subject, t.posted, t.closed, p.poster, p.poster_id, p.message, p.hide_smilies FROM '.$db->prefix.'posts AS p INNER JOIN '.$db->prefix.'topics AS t ON t.id=p.topic_id INNER JOIN '.$db->prefix.'forums AS f ON f.id=t.forum_id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND p.id='.$id) or error('Impossible de retrouver les informations des messages', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
	message($lang_common['Bad request']);

$cur_post = $db->fetch_assoc($result);

// Sort out who the moderators are and if we are currently a moderator (or an admin)
$mods_array = ($cur_post['moderators'] != '') ? unserialize($cur_post['moderators']) : array();
$is_admmod = ($pun_user['g_id'] == PUN_ADMIN || ($pun_user['g_id'] == PUN_MOD && array_key_exists($pun_user['username'], $mods_array))) ? true : false;

// Determine whether this post is the "topic post" or not
$result = $db->query('SELECT id FROM '.$db->prefix.'posts WHERE topic_id='.$cur_post['tid'].' ORDER BY posted LIMIT 1') or error('Impossible de retrouver les informations des messages', __FILE__, __LINE__, $db->error());
$topic_post_id = $db->result($result);

$can_edit_subject = ($id == $topic_post_id && (($pun_user['g_edit_subjects_interval'] == '0' || (time() - $cur_post['posted']) < $pun_user['g_edit_subjects_interval']) || $is_admmod)) ? true : false;

// Do we have permission to edit this post?
if (($pun_user['g_edit_posts'] == '0' ||
	$cur_post['poster_id'] != $pun_user['id'] ||
	$cur_post['closed'] == '1') &&
	!$is_admmod)
	message($lang_common['No permission']);

// Load the post.php/edit.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/post.php';

// Start with a clean slate
$errors = array();


if (isset($_POST['form_sent']))
{
	if ($is_admmod)
		confirm_referrer('edit.php');

	// If it is a topic it must contain a subject
	if ($can_edit_subject)
	{
		$subject = pun_trim($_POST['req_subject']);

		if ($subject == '')
			$errors[] = $lang_post['No subject'];
		else if (pun_strlen($subject) > 70)
			$errors[] = $lang_post['Too long subject'];
		else if ($pun_config['p_subject_all_caps'] == '0' && strtoupper($subject) == $subject && $pun_user['g_id'] > PUN_MOD)
			$subject = ucwords(strtolower($subject));
	}

	// Clean up message from POST
	$message = pun_linebreaks(pun_trim($_POST['req_message']));

	if ($message == '')
		$errors[] = $lang_post['No message'];
	else if (strlen($message) > 65535)
		$errors[] = $lang_post['Too long message'];
	else if ($pun_config['p_message_all_caps'] == '0' && strtoupper($message) == $message && $pun_user['g_id'] > PUN_MOD)
		$message = ucwords(strtolower($message));

	// Validate BBCode syntax
	if ($pun_config['p_message_bbcode'] == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
	{
		require PUN_ROOT.'include/parser.php';
		$message = preparse_bbcode($message, $errors);
	}


	$hide_smilies = isset($_POST['hide_smilies']) ? intval($_POST['hide_smilies']) : 0;
	if ($hide_smilies != '1') $hide_smilies = '0';

	// Did everything go according to plan?
	if (empty($errors) && !isset($_POST['preview']))
	{
		$edited_sql = (!isset($_POST['silent']) || !$is_admmod) ? $edited_sql = ', edited='.time().', edited_by=\''.$db->escape($pun_user['username']).'\'' : '';

		require PUN_ROOT.'include/search_idx.php';

		if ($can_edit_subject)
		{
			// Update the topic and any redirect topics
			$db->query('UPDATE '.$db->prefix.'topics SET subject=\''.$db->escape($subject).'\' WHERE id='.$cur_post['tid'].' OR moved_to='.$cur_post['tid']) or error('Impossible de modifier la discussion', __FILE__, __LINE__, $db->error());

			// We changed the subject, so we need to take that into account when we update the search words
			update_search_index('edit', $id, $message, $subject);
		}
		else
			update_search_index('edit', $id, $message);

		// Update the post
		$db->query('UPDATE '.$db->prefix.'posts SET message=\''.$db->escape($message).'\', hide_smilies=\''.$hide_smilies.'\''.$edited_sql.' WHERE id='.$id) or error('Impossible de modifier le message', __FILE__, __LINE__, $db->error());

		redirect('viewtopic.php?pid='.$id.'#p'.$id, $lang_post['Edit redirect']);
	}
}



/* <Mgs-01> - Fabrication du chemin d'acces (ajout) */
$mgs_chemin = '<a href="index.php">'.($lang_common['Index']).'</a> &gt; '.'<a href="viewforum.php?id='.($cur_post['fid']).'">'.(pun_htmlspecialchars($cur_post['forum_name'])).'</a> &gt; <strong>'.(pun_htmlspecialchars($cur_post['subject'])).'</strong>';
/* </Mgs-01> */

$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_post['Edit post'];
$required_fields = array('req_subject' => $lang_common['Subject'], 'req_message' => $lang_common['Message']);
$focus_element = array('edit', 'req_message');
require PUN_ROOT.'header.php';

$cur_index = 1;

?>

<?php /* <Mgs-02> - Inhbition du code original (modif) */
/*
<div class="linkst">
	<div class="inbox">
		<ul><li><a href="index.php"><?php echo $lang_common['Index'] ?></a></li><li>&#160;&raquo;&#160;<a href="viewforum.php?id=<?php echo $cur_post['fid'] ?>"><?php echo pun_htmlspecialchars($cur_post['forum_name']) ?></a></li><li>&#160;&raquo;&#160;<?php echo pun_htmlspecialchars($cur_post['subject']) ?></li></ul>
	</div>
</div>
*/ 
/* </Mgs-02> */ ?>

<?php

// If there are errors, we display them
if (!empty($errors))
{

?>
<div id="posterror" class="block">
	<h2><span><?php echo $lang_post['Post errors'] ?></span></h2>
	<div class="box">
		<div class="inbox"
			<p><?php echo $lang_post['Post errors info'] ?></p>
			<ul>
<?php

	while (list(, $cur_error) = each($errors))
		echo "\t\t\t\t".'<li><strong>'.$cur_error.'</strong></li>'."\n";
?>
			</ul>
		</div>
	</div>
</div>

<?php

}
else if (isset($_POST['preview']))
{
	require_once PUN_ROOT.'include/parser.php';
	$preview_message = parse_message($message, $hide_smilies);

?>
<div id="postpreview" class="blockpost">
	<h2><span><?php echo $lang_post['Post preview'] ?></span></h2>
	<div class="box">
		<div class="inbox">
			<div class="postright">
				<div class="postmsg">
					<?php echo $preview_message."\n" ?>
				</div>
			</div>
		</div>
	</div>
</div>

<?php

}

?>
<div class="blockform">
	<h2><?php echo $lang_post['Edit post'] ?></h2>
	<div class="box">
		<form id="edit" method="post" action="edit.php?id=<?php echo $id ?>&amp;action=edit" onsubmit="return process_form(this)">
			<div class="inform">
				<fieldset id="textform">
					<legend><?php echo $lang_post['Edit post legend'] ?></legend>
					<input type="hidden" name="form_sent" value="1" />
					<div class="infldset txtarea">
<?php if ($can_edit_subject): ?>						<label><?php echo $lang_common['Subject'] ?><br />
						<input class="longinput" type="text" name="req_subject" size="80" maxlength="70" tabindex="<?php echo $cur_index++ ?>" value="<?php echo pun_htmlspecialchars(isset($_POST['req_subject']) ? $_POST['req_subject'] : $cur_post['subject']) ?>" /><br /></label>
						
<?php /* <Mgs-03> - Adaptation du code original et integration des emoticones et options cliquables (modif-ajout) */ ?>
<?php endif; ?>						<label><strong><?php echo $lang_common['Message'] ?></strong><br />
						<textarea id="req_message" name="req_message" rows="25" cols="125"  style="padding: 6px 8px 8px 8px; width: 640px;" tabindex="<?php echo $cur_index++ ?>"><?php echo isset($_POST['req_message']) ? pun_htmlspecialchars($message) : $cur_post['message'] ?></textarea><br /></label>
						<script type="text/javascript" language="javascript">  
						<!--
						labelList = new Array("Veuillez noter l'adresse Url :", "Veuillez noter le texte de l'infobulle :", "Veuillez noter l'adresse E-mail :", "Veuillez noter le nom du style :", "Veuillez noter le nom de l'auteur :", "Veuillez noter l'adresse Url de l'image :", "Veuillez noter le nom ou le code de la couleur :");
						
						function text_sel() {
							var input = document.forms['edit'].elements['req_message'];
							input.focus();
							if (typeof document.selection != 'undefined') { /* pour l'Explorer Internet */
								var range = document.selection.createRange();
								return range.text;
							} else if (typeof input.selectionStart != 'undefined') { /* pour navigateurs bases sur Gecko */
								var start = input.selectionStart;
								var end = input.selectionEnd;
								return input.value.substring(start, end);
							} else {
								return '';
							}
						}
						function insert_prompt(open, close, selOk, label1, label2) {
							if (selOk) { var textSel = text_sel(); } else { var textSel = ''; }
							if (label1 != null) {
								var attribut = prompt(labelList[label1], textSel);
								if (attribut != null && attribut != '') {
									open = open + '=' + attribut + ']';
								} else {
									if (label1 == 5 || label1 == 6) { return; }
									open = open + ']';
								}
							}
							if (label2 != null) {
								var infobulle = prompt(labelList[label2]);
								if (infobulle != null && infobulle != '') {
									close = '|' + infobulle + close;
								}
							}
							insert_text(open, close);
						}
						/* http://actuel.fr.selfhtml.org/articles/javascript/bbcode/index.htm */
						function insert_text(repdeb, repfin) {
							var input = document.forms['edit'].elements['req_message'];
							input.focus();
							if (typeof document.selection != 'undefined') { /* pour l'Explorer Internet */
								/* Insertion du code de formatage */
								var range = document.selection.createRange();
								var insText = range.text;
								range.text = repdeb + insText + repfin;
								/* Ajustement de la position du curseur */
								range = document.selection.createRange();
								if (insText.length == 0) {
									if (repdeb.length == 0) {
										range.move('character', repfin.length);
									} else {
										range.move('character', -repfin.length);
									}
								} else {
									range.moveStart('character', repdeb.length + insText.length + repfin.length);
								}
								range.select();
							} else if (typeof input.selectionStart != 'undefined') { /* pour navigateurs bases sur Gecko */
								/* Insertion du code de formatage */
								var start = input.selectionStart;
								var end = input.selectionEnd;
								var insText = input.value.substring(start, end);
								input.value = input.value.substr(0, start) + repdeb + insText + repfin + input.value.substr(end);
								/* Ajustement de la position du curseur */
								var pos;
								if (insText.length == 0) {
									if (repdeb.length == 0) {
										pos = start + repfin.length;
									} else {
										pos = start + repdeb.length;
									}
								} else {
									pos = start + repdeb.length + insText.length + repfin.length;
								}
								input.selectionStart = pos;
								input.selectionEnd = pos;
							} else { /* pour les autres navigateurs */
								var pos = input.value.length;
								/* Insertion du code de formatage */
								var insText = prompt("Veuillez noter le texte à insérer :");
								input.value = input.value.substr(0, pos) + repdeb + insText + repfin + input.value.substr(pos);
							}
						}
						// -->
						</script>
						<div style="margin: 4px 0px; padding: 2px 8px 4px 8px; width: 622px; border: 1px solid silver; background-color: #f9f9f9">
							<div style="margin: 2px 0px 6px 0px;">
								<strong>&Eacute;motic&ocirc;nes&nbsp;:&nbsp; </strong>  
								<a href="#textform" onclick="insert_text('', ' :) '); return false"><img border="0" src="img/smilies/smile.png" width="15" height="15" alt=":)" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :| '); return false"><img border="0" src="img/smilies/neutral.png" width="15" height="15" alt=":|" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :( '); return false"><img border="0" src="img/smilies/sad.png" width="15" height="15" alt=":(" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :D '); return false"><img border="0" src="img/smilies/big_smile.png" width="15" height="15" alt=":D" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :o '); return false"><img border="0" src="img/smilies/yikes.png" width="15" height="15" alt=":o" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' ;) '); return false"><img border="0" src="img/smilies/wink.png" width="15" height="15" alt=";)" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :/ '); return false"><img border="0" src="img/smilies/hmm.png" width="15" height="15" alt=":/" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :P '); return false"><img border="0" src="img/smilies/tongue.png" width="15" height="15" alt=":P" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :lol: '); return false"><img border="0" src="img/smilies/lol.png" width="15" height="15" alt=":lol:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :mad: '); return false"><img border="0" src="img/smilies/mad.png" width="15" height="15" alt=":mad:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :rolleyes: '); return false"><img border="0" src="img/smilies/roll.png" width="15" height="15" alt=":rolleyes:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :cool: '); return false"><img border="0" src="img/smilies/cool.png" width="15" height="15" alt=":cool:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :blink: '); return false"><img border="0" src="img/smilies/blink.gif" width="15" height="15" alt=":blink:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :cheese: '); return false"><img border="0" src="img/smilies/cheese.gif" width="15" height="15" alt=":cheese:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :huh: '); return false"><img border="0" src="img/smilies/huh.gif" width="15" height="15" alt=":huh:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :mdr: '); return false"><img border="0" src="img/smilies/mdr.gif" width="15" height="15" alt=":mdr:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :not: '); return false"><img border="0" src="img/smilies/non.gif" width="15" height="15" alt=":non:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :yes: '); return false"><img border="0" src="img/smilies/oui.gif" width="15" height="15" alt=":oui:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :pleure: '); return false"><img border="0" src="img/smilies/pleure.gif" width="17" height="15" alt=":pleure:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :siffle: '); return false"><img border="0" src="img/smilies/siffle.gif" width="25" height="15" alt=":siffle:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :top: '); return false"><img border="0" src="img/smilies/top.gif" width="17" height="20" alt=":top:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :unsure: '); return false"><img border="0" src="img/smilies/unsure.gif" width="15" height="15" alt=":unsure:" /></a>&nbsp;
							</div>
							<div style="margin: 6px 0px;">
								<strong>Style du texte&nbsp;:&nbsp; </strong>  
								<a href="#textform" onclick="insert_text('[b]','[/b]'); return false"><strong>Gras</strong></a>&nbsp;
								<a href="#textform" onclick="insert_text('[i]','[/i]'); return false"><em>Italique</em></a>&nbsp;
								<a href="#textform" onclick="insert_text('[u]','[/u]'); return false"><ins>Soulign&eacute;</ins></a>&nbsp;
								<a href="#textform" onclick="insert_text('[s]','[/s]'); return false"><del>Barr&eacute;</del></a>&nbsp;
								|&nbsp;
								<a href="#textform" onclick="insert_text('[color=red]','[/color]'); return false"><span style="color: red">Rouge</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=green]','[/color]'); return false"><span style="color: green">Vert</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=blue]','[/color]'); return false"><span style="color: blue">Bleu</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=maroon]','[/color]'); return false"><span style="color: maroon">Marron</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=orange]','[/color]'); return false"><span style="color: orange">Orange</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=navy]','[/color]'); return false"><span style="color: navy">Marine</span></a>&nbsp;- 
								<a href="#textform" onclick="insert_prompt('[color','[/color]',false,6,null); return false"><span style="color: black">Autre</span></a>&nbsp;
							</div>
							<div style="margin: 6px 0px;">
								<strong>Liens et blocs&nbsp;:&nbsp; </strong>  
								<a href="#textform" onclick="insert_prompt('[url','[/url]',true,0,1); return false">Lien Url</a>&nbsp;
								<a href="#textform" onclick="insert_prompt('[email','[/email]',true,2,1); return false">Lien Email</a>&nbsp;
								<a href="#textform" onclick="insert_text('[img]','[/img]'); return false">Lien Image</a>&nbsp;
								|&nbsp;
								<a href="#textform" onclick="insert_prompt('[quote','[/quote]',false,4,null); return false">Bloc Citation</a>&nbsp;
								<a href="#textform" onclick="insert_text('[code]','[/code]'); return false">Bloc Code</a>&nbsp;
								<a href="#textform" onclick="insert_prompt('[box','[/box]',false,5,null); return false">Bloc Libre</a>&nbsp;
								|&nbsp;
								<a href="#textform" onclick="insert_text('[center]','[/center]'); return false">Centrer</a>&nbsp;
								<a href="#textform" onclick="insert_text('',' [hr] '); return false">Filet</a>&nbsp;
							</div>
						</div>
<?php /* </Mgs-03> */ ?>
						<ul class="bblinks">
							<li><a href="help.php#bbcode" onclick="window.open(this.href); return false;"><?php echo $lang_common['BBCode'] ?></a>: <?php echo ($pun_config['p_message_bbcode'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#img" onclick="window.open(this.href); return false;"><?php echo $lang_common['img tag'] ?></a>: <?php echo ($pun_config['p_message_img_tag'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#smilies" onclick="window.open(this.href); return false;"><?php echo $lang_common['Smilies'] ?></a>: <?php echo ($pun_config['o_smilies'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
						</ul>
					</div>
				</fieldset>
<?php

$checkboxes = array();
if ($pun_config['o_smilies'] == '1')
{
	if (isset($_POST['hide_smilies']) || $cur_post['hide_smilies'] == '1')
		$checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" checked="checked" tabindex="'.($cur_index++).'" />&#160;'.$lang_post['Hide smilies'];
	else
		$checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="'.($cur_index++).'" />&#160;'.$lang_post['Hide smilies'];
}

if ($is_admmod)
{
	if ((isset($_POST['form_sent']) && isset($_POST['silent'])) || !isset($_POST['form_sent']))
		$checkboxes[] = '<label><input type="checkbox" name="silent" value="1" tabindex="'.($cur_index++).'" checked="checked" />&#160;'.$lang_post['Silent edit'];
	else
		$checkboxes[] = '<label><input type="checkbox" name="silent" value="1" tabindex="'.($cur_index++).'" />&#160;'.$lang_post['Silent edit'];
}

if (!empty($checkboxes))
{

?>
			</div>
			<div class="inform">
				<fieldset>
					<legend><?php echo $lang_common['Options'] ?></legend>
					<div class="infldset">
						<div class="rbox">
							<?php echo implode('</label>'."\n\t\t\t\t\t\t\t", $checkboxes).'</label>'."\n" ?>
						</div>
					</div>
				</fieldset>
<?php

	}

?>
			</div>
		<div>
			<fieldset>
			<legend>Validation</legend>
			<div class="infldset" style="text-align: center; padding: 2px 2px 6px 2px;">
			<p><input type="submit" name="submit" value="&nbsp;&nbsp;<?php echo $lang_common['Submit'] ?>&nbsp;&nbsp;" tabindex="<?php echo $cur_index++ ?>" accesskey="s" /><input type="submit" name="preview" value="&nbsp;&nbsp;<?php echo $lang_post['Preview'] ?>&nbsp;&nbsp;" tabindex="<?php echo $cur_index++ ?>" accesskey="p" /><a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a></p>
			</div>
			</fieldset>
		</div>

		</form>
	</div>
</div>
<?php

require PUN_ROOT.'footer.php';
