<?php

/***********************************************************************

  Copyright (C) 2002-2005  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*********** Captcha Visiteurs ***********/
/* Solution de securite pour limiter l'acces des robots spameurs */
/* Base sur une proposition de vin100 sur le forum PunBbFr */
/* voir : <http://www.punbb.fr/forums/viewtopic.php?pid=30840> */
/* Realisation : FredoMkb (c) 2006 */
/**************************************/
/* Valeurs globales */
// Tableau "questions/reponses" (a adapter selon vos besoins).
$cptchList = array(
	'1 + 3' => 4,
	'1 - 1' => 0,
	'2 + 6' => 8,
	'2 - 1' => 1,
	'3 + 6' => 9,
	'3 - 2' => 1,
	'4 + 8' => 12,
	'4 - 2' => 2,
	'5 + 3' => 8,
	'5 - 2' => 3,
	'6 + 4' => 10,
	'6 - 3' => 3,
	'7 + 7' => 14,
	'7 - 5' => 2,
	'8 + 8' => 16,
	'8 - 5' => 3,
	'9 + 3' => 12,
	'9 - 4' => 5,
	'10 + 8' => 18,
	'10 - 4' => 6
);
// Tableau des conseils (a adapter selon vos besoins)
$conseilsList = array(
	'Et si vous mettiez vos lunettes l&agrave;... hein ? ;-)',
	'Je crois vous devriez vous faire aider l&agrave;... ;-)',
	'Accrochez-vous... vous allez y arriver... ;-)',
	'Et bein... vous devriez changer de cerveau... ;-)',
	'Et si vous utilisiez une calculette l&agrave;... non ? ;-)',
	'Euh... vous devriez vous r&eacute;poser un peu l&agrave;... ;-)',
	'&Ccedil;a alors... vous devriez retouner &agrave; l\'&eacute;cole... ;-)',
	'Faut pas d&eacute;primer... &ccedil;a arrive &agrave; tout le monde... ;-)',
	'Vous devriez vous procurer quelques neurones... ;-)',
	'Faut pas vous d&eacute;courager... vous y &ecirc;tes presque... ;-)'
);
/* Fonctions de traitement */
// Fonction pour convertir du texte Html en codes Ascii Html.
function asciihtml($textHtml) {
/* Fonction pour retourner le texte Html fourni ($textHtml) converti en codes Ascii Html ($asciiHtml). */
/* Petite adaptation d'un code issu d'une contribution sur Spip'Contrib proposee par Jean Luc Girard et Coyote, merci a eux. */
/* Voir : <http://www.spip-contrib.net/Crypter-une-adresse-email> */
/* Utf<->Html, johan dot andersson at strateg dot se, voir : <http://fr.php.net/manual/fr/function.utf8-decode.php#31815> */
	$textHtml = html_entity_decode(htmlentities($textHtml, ENT_COMPAT, 'UTF-8'));
	$asciiHtml = '';
	for ($i = 0; $i < strlen($textHtml); $i++) {
		$asciiHtml .= '&#'.ord($textHtml[$i]).';';
	}
	return $asciiHtml;
}
// Fonction pour preparer la question du captcha
function cptchQuestion() {
	global $cptchList; // Utiliser les globales
	// Construction de la question
	$cptchIndex = rand(0, count($cptchList)-1); // Choix aleatoire d'un couple "question/reponse"
	$cptchQstsList = array_keys($cptchList); // Liste des questions
	$cptchQst = $cptchQstsList[$cptchIndex]; // La question choisie
	$cptchQstMd5 = md5($cptchQst); // Encodage md5 de la question choisie
	$cptchQstHtml = asciihtml($cptchQst.' ='); // Encodage ascii html de la question choisie
	// Retour des resultats
	$resultArray = array($cptchQstHtml, $cptchQstMd5);
	return $resultArray;
}
// Fonction pour analyser la reponse au captcha
function cptchReponse() {
	global $cptchList, $conseilsList, $lang_common; // Utiliser les globales
	$limite = 3; // Nombre de tentatives autorisees (a adapter selon vos besoins)
	$conseil = $conseilsList[rand(0, count($conseilsList)-1)]; // Choix aleatoire d'un conseil
	// Construction du tableau de controle de la reponse fournie
	$cptchQstsMd5List = array();
	foreach ($cptchList as $cle => $val) {
		$cptchQstsMd5List[md5($cle)] = $val;
	}
	// Recuperation des varialbes passees par $_POST
	$cptchQstUsr = trim($_POST['captcha_q']);
	$cptchRepUsr = trim($_POST['captcha']);
	$messageOk = 0;
	if (empty($cptchQstsMd5List[$cptchQstUsr]) || $cptchQstsMd5List[$cptchQstUsr] != $cptchRepUsr) { $messageOk = 1; }
	// Initialisation d'une session pour compter le nombre de tentatives
	$suiteOk = 0;
	session_start(); // Demarrage de la session
	if (isset($_SESSION['nbr'])) {
		$_SESSION['nbr'] ++;  // Iteration du compteur
		if ($_SESSION['nbr'] >= $limite) { $suiteOk = 1; }
	} else {
		$_SESSION['nbr'] = 1; // Initialisation du compteur
	}
	// Construction des messages d'erreur
	$message = '<p><strong>R&eacute;ponse incorrecte, veuillez recommencer... </strong>';
	$message .= '<small style="color: gray;">(tentative '.$_SESSION['nbr'].'/'.$limite.')</small></p>';
	$message .= '<p>Conseil : <em>'.$conseil.'</em></p>';
	// Avertissement et lien lorsque la limite est depassee
	$averto = '<p><strong style="color: maroon;">Vous avez &eacute;puis&eacute; le nombre de tentatives autoris&eacute;es !</strong></p>';
	$averto .= '<p><a href="javascript:location.href=location">'.$lang_common['Go back'].'</a></p>';
	if ($suiteOk) { $message .= $averto; }
	// Supperssion du compteur de la session lorsque la limite est depassee
	if ($_SESSION['nbr'] >= $limite) { unset($_SESSION['nbr']); }
	// Retour des resultats

	$resultArray = array($messageOk, $message, $suiteOk);
	return $resultArray;
}
/*********** Fin Captcha Visiteurs ***********/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


if ($pun_user['g_read_board'] == '0')
	message($lang_common['No view']);


$tid = isset($_GET['tid']) ? intval($_GET['tid']) : 0;
$fid = isset($_GET['fid']) ? intval($_GET['fid']) : 0;
if ($tid < 1 && $fid < 1 || $tid > 0 && $fid > 0)
	message($lang_common['Bad request']);

// Fetch some info about the topic and/or the forum
if ($tid)
	$result = $db->query('SELECT f.id, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.subject, t.closed FROM '.$db->prefix.'topics AS t INNER JOIN '.$db->prefix.'forums AS f ON f.id=t.forum_id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.id='.$tid) or error('Impossible de retrouver les informations forum', __FILE__, __LINE__, $db->error());
else
	$result = $db->query('SELECT f.id, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics FROM '.$db->prefix.'forums AS f LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id='.$fid) or error('Impossible de retrouver les informations forum', __FILE__, __LINE__, $db->error());

if (!$db->num_rows($result))
	message($lang_common['Bad request']);

$cur_posting = $db->fetch_assoc($result);

// Is someone trying to post into a redirect forum?
if ($cur_posting['redirect_url'] != '')
	message($lang_common['Bad request']);

// Sort out who the moderators are and if we are currently a moderator (or an admin)
$mods_array = ($cur_posting['moderators'] != '') ? unserialize($cur_posting['moderators']) : array();
$is_admmod = ($pun_user['g_id'] == PUN_ADMIN || ($pun_user['g_id'] == PUN_MOD && array_key_exists($pun_user['username'], $mods_array))) ? true : false;

// Do we have permission to post?
if ((($tid && (($cur_posting['post_replies'] == '' && $pun_user['g_post_replies'] == '0') || $cur_posting['post_replies'] == '0')) ||
	($fid && (($cur_posting['post_topics'] == '' && $pun_user['g_post_topics'] == '0') || $cur_posting['post_topics'] == '0')) ||
	(isset($cur_posting['closed']) && $cur_posting['closed'] == '1')) &&
	!$is_admmod)
	message($lang_common['No permission']);

// Load the post.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/post.php';

// Start with a clean slate
$errors = array();


// Did someone just hit "Submit" or "Preview"?
if (isset($_POST['form_sent']))
{
	/*********** Captcha Reponse ***********/
	if ($pun_user['is_guest']) {
		$cptchRepRes = cptchReponse();
		if ($cptchRepRes[0]) { message($cptchRepRes[1], $cptchRepRes[2]); }
	}
	/*********** Fin Captcha Reponse ***********/

	// Make sure form_user is correct
	if (($pun_user['is_guest'] && $_POST['form_user'] != 'Invité') || (!$pun_user['is_guest'] && $_POST['form_user'] != $pun_user['username']))
		message($lang_common['Bad request']);

	// Flood protection
	if (!$pun_user['is_guest'] && !isset($_POST['preview']) && $pun_user['last_post'] != '' && (time() - $pun_user['last_post']) < $pun_user['g_post_flood'])
		$errors[] = $lang_post['Flood start'].' '.$pun_user['g_post_flood'].' '.$lang_post['flood end'];

	// If it's a new topic
	if ($fid)
	{
		$subject = pun_trim($_POST['req_subject']);

		if ($subject == '')
			$errors[] = $lang_post['No subject'];
		else if (pun_strlen($subject) > 70)
			$errors[] = $lang_post['Too long subject'];
		else if ($pun_config['p_subject_all_caps'] == '0' && strtoupper($subject) == $subject && $pun_user['g_id'] > PUN_MOD)
			$subject = ucwords(strtolower($subject));
	}

	// If the user is logged in we get the username and e-mail from $pun_user
	if (!$pun_user['is_guest'])
	{
		$username = $pun_user['username'];
		$email = $pun_user['email'];
	}
	// Otherwise it should be in $_POST
	else
	{
		$username = trim($_POST['req_username']);
		$email = strtolower(trim(($pun_config['p_force_guest_email'] == '1') ? $_POST['req_email'] : $_POST['email']));

		// Load the register.php/profile.php language files
		require PUN_ROOT.'lang/'.$pun_user['language'].'/prof_reg.php';
		require PUN_ROOT.'lang/'.$pun_user['language'].'/register.php';

		// It's a guest, so we have to validate the username
		if (strlen($username) < 2)
			$errors[] = $lang_prof_reg['Username too short'];
		else if (!strcasecmp($username, 'Guest') || !strcasecmp($username, 'invité') || !strcasecmp($username, $lang_common['Guest']))
			$errors[] = $lang_prof_reg['Username guest'];
		else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
			$errors[] = $lang_prof_reg['Username IP'];

		if ((strpos($username, '[') !== false || strpos($username, ']') !== false) && strpos($username, '\'') !== false && strpos($username, '"') !== false)
			$errors[] = $lang_prof_reg['Username reserved chars'];
		if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
			$errors[] = $lang_prof_reg['Username BBCode'];

		// Check username for any censored words
		$temp = censor_words($username);
		if ($temp != $username)
			$errors[] = $lang_register['Username censor'];

		// Check that the username (or a too similar username) is not already registered
		$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE username=\''.$db->escape($username).'\' OR username=\''.$db->escape(preg_replace('/[^\w]/', '', $username)).'\'') or error('Impossible de retrouver les informations utilisateur', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
		{
			$busy = $db->result($result);
			$errors[] = $lang_register['Username dupe 1'].' '.pun_htmlspecialchars($busy).'. '.$lang_register['Username dupe 2'];
		}

		if ($pun_config['p_force_guest_email'] == '1' || $email != '')
		{
			require PUN_ROOT.'include/email.php';
			if (!is_valid_email($email))
				$errors[] = $lang_common['Invalid e-mail'];
		}
	}

	// Clean up message from POST
	$message = pun_linebreaks(pun_trim($_POST['req_message']));

	if ($message == '')
		$errors[] = $lang_post['No message'];
	else if (strlen($message) > 65535)
		$errors[] = $lang_post['Too long message'];
	else if ($pun_config['p_message_all_caps'] == '0' && strtoupper($message) == $message && $pun_user['g_id'] > PUN_MOD)
		$message = ucwords(strtolower($message));

	// Validate BBCode syntax
	if ($pun_config['p_message_bbcode'] == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
	{
		require PUN_ROOT.'include/parser.php';
		$message = preparse_bbcode($message, $errors);
	}


	require PUN_ROOT.'include/search_idx.php';

	$hide_smilies = isset($_POST['hide_smilies']) ? 1 : 0;
	$subscribe = isset($_POST['subscribe']) ? 1 : 0;

	$now = time();

	// Did everything go according to plan?
	if (empty($errors) && !isset($_POST['preview']))
	{
		// If it's a reply
		if ($tid)
		{
			if (!$pun_user['is_guest'])
			{
				// Insert the new post
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id) VALUES(\''.$db->escape($username).'\', '.$pun_user['id'].', \''.get_remote_address().'\', \''.$db->escape($message).'\', \''.$hide_smilies.'\', '.$now.', '.$tid.')') or error('Impossible de créer le message', __FILE__, __LINE__, $db->error());
				$new_pid = $db->insert_id();

				// To subscribe or not to subscribe, that ...
				if ($pun_config['o_subscriptions'] == '1' && $subscribe)
				{
					$result = $db->query('SELECT 1 FROM '.$db->prefix.'subscriptions WHERE user_id='.$pun_user['id'].' AND topic_id='.$tid) or error('Impossible de retrouver les informations d\'abonnement', __FILE__, __LINE__, $db->error());
					if (!$db->num_rows($result))
						$db->query('INSERT INTO '.$db->prefix.'subscriptions (user_id, topic_id) VALUES('.$pun_user['id'].' ,'.$tid.')') or error('Impossible d\'ajouter l\'abonnement', __FILE__, __LINE__, $db->error());
				}
			}
			else
			{
				// It's a guest. Insert the new post
				$email_sql = ($pun_config['p_force_guest_email'] == '1' || $email != '') ? '\''.$email.'\'' : 'NULL';
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_ip, poster_email, message, hide_smilies, posted, topic_id) VALUES(\''.$db->escape($username).'\', \''.get_remote_address().'\', '.$email_sql.', \''.$db->escape($message).'\', \''.$hide_smilies.'\', '.$now.', '.$tid.')') or error('Impossible de créer le message', __FILE__, __LINE__, $db->error());
				$new_pid = $db->insert_id();
			}

			// Count number of replies in the topic
			$result = $db->query('SELECT COUNT(id) FROM '.$db->prefix.'posts WHERE topic_id='.$tid) or error('Impossible de retrouver le total de messages de la discussion', __FILE__, __LINE__, $db->error());
			$num_replies = $db->result($result, 0) - 1;

			// Update topic
			$db->query('UPDATE '.$db->prefix.'topics SET num_replies='.$num_replies.', last_post='.$now.', last_post_id='.$new_pid.', last_poster=\''.$db->escape($username).'\' WHERE id='.$tid) or error('Impossible de modifier la discussion', __FILE__, __LINE__, $db->error());

			update_search_index('post', $new_pid, $message);

			update_forum($cur_posting['id']);

			// Should we send out notifications?
			if ($pun_config['o_subscriptions'] == '1')
			{
				// Get the post time for the previous post in this topic
				$result = $db->query('SELECT posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id DESC LIMIT 1, 1') or error('Impossible de retrouver les information de message', __FILE__, __LINE__, $db->error());
				$previous_post_time = $db->result($result);

				// Get any subscribed users that should be notified (banned users are excluded)
				$result = $db->query('SELECT u.id, u.email, u.notify_with_post, u.language FROM '.$db->prefix.'users AS u INNER JOIN '.$db->prefix.'subscriptions AS s ON u.id=s.user_id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id='.$cur_posting['id'].' AND fp.group_id=u.group_id) LEFT JOIN '.$db->prefix.'online AS o ON u.id=o.user_id LEFT JOIN '.$db->prefix.'bans AS b ON u.username=b.username WHERE b.username IS NULL AND COALESCE(o.logged, u.last_visit)>'.$previous_post_time.' AND (fp.read_forum IS NULL OR fp.read_forum=1) AND s.topic_id='.$tid.' AND u.id!='.intval($pun_user['id'])) or error('Impossible de retrouver les informations d\'abonnement', __FILE__, __LINE__, $db->error());
				if ($db->num_rows($result))
				{
					require_once PUN_ROOT.'include/email.php';

					$notification_emails = array();

					// Loop through subscribed users and send e-mails
					while ($cur_subscriber = $db->fetch_assoc($result))
					{
						// Is the subscription e-mail for $cur_subscriber['language'] cached or not?
						if (!isset($notification_emails[$cur_subscriber['language']]))
						{
							if (file_exists(PUN_ROOT.'lang/'.$cur_subscriber['language'].'/mail_templates/new_reply.tpl'))
							{
								// Load the "new reply" template
								$mail_tpl = trim(file_get_contents(PUN_ROOT.'lang/'.$cur_subscriber['language'].'/mail_templates/new_reply.tpl'));

								// Load the "new reply full" template (with post included)
								$mail_tpl_full = trim(file_get_contents(PUN_ROOT.'lang/'.$cur_subscriber['language'].'/mail_templates/new_reply_full.tpl'));

								// The first row contains the subject (it also starts with "Subject:")
								$first_crlf = strpos($mail_tpl, "\n");
								$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
								$mail_message = trim(substr($mail_tpl, $first_crlf));

								$first_crlf = strpos($mail_tpl_full, "\n");
								$mail_subject_full = trim(substr($mail_tpl_full, 8, $first_crlf-8));
								$mail_message_full = trim(substr($mail_tpl_full, $first_crlf));

								$mail_subject = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_subject);
								$mail_message = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_message);
								$mail_message = str_replace('<replier>', $username, $mail_message);
								$mail_message = str_replace('<post_url>', $pun_config['o_base_url'].'/viewtopic.php?pid='.$new_pid.'#p'.$new_pid, $mail_message);
								$mail_message = str_replace('<unsubscribe_url>', $pun_config['o_base_url'].'/misc.php?unsubscribe='.$tid, $mail_message);
								$mail_message = str_replace('<board_mailer>', $pun_config['o_board_title'].' '.$lang_common['Mailer'], $mail_message);

								$mail_subject_full = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_subject_full);
								$mail_message_full = str_replace('<topic_subject>', '\''.$cur_posting['subject'].'\'', $mail_message_full);
								$mail_message_full = str_replace('<replier>', $username, $mail_message_full);
								$mail_message_full = str_replace('<message>', $message, $mail_message_full);
								$mail_message_full = str_replace('<post_url>', $pun_config['o_base_url'].'/viewtopic.php?pid='.$new_pid.'#p'.$new_pid, $mail_message_full);
								$mail_message_full = str_replace('<unsubscribe_url>', $pun_config['o_base_url'].'/misc.php?unsubscribe='.$tid, $mail_message_full);
								$mail_message_full = str_replace('<board_mailer>', $pun_config['o_board_title'].' '.$lang_common['Mailer'], $mail_message_full);

								$notification_emails[$cur_subscriber['language']][0] = $mail_subject;
								$notification_emails[$cur_subscriber['language']][1] = $mail_message;
								$notification_emails[$cur_subscriber['language']][2] = $mail_subject_full;
								$notification_emails[$cur_subscriber['language']][3] = $mail_message_full;

								$mail_subject = $mail_message = $mail_subject_full = $mail_message_full = null;
							}
						}

						// We have to double check here because the templates could be missing
						if (isset($notification_emails[$cur_subscriber['language']]))
						{
							if ($cur_subscriber['notify_with_post'] == '0')
								pun_mail($cur_subscriber['email'], $notification_emails[$cur_subscriber['language']][0], $notification_emails[$cur_subscriber['language']][1]);
							else
								pun_mail($cur_subscriber['email'], $notification_emails[$cur_subscriber['language']][2], $notification_emails[$cur_subscriber['language']][3]);
						}
					}
				}
			}
		}
		// If it's a new topic
		else if ($fid)
		{
			// Create the topic
			$db->query('INSERT INTO '.$db->prefix.'topics (poster, subject, posted, last_post, last_poster, forum_id) VALUES(\''.$db->escape($username).'\', \''.$db->escape($subject).'\', '.$now.', '.$now.', \''.$db->escape($username).'\', '.$fid.')') or error('Impossible de créer la discussion', __FILE__, __LINE__, $db->error());
			$new_tid = $db->insert_id();

			if (!$pun_user['is_guest'])
			{
				// To subscribe or not to subscribe, that ...
				if ($pun_config['o_subscriptions'] == '1' && (isset($_POST['subscribe']) && $_POST['subscribe'] == '1'))
					$db->query('INSERT INTO '.$db->prefix.'subscriptions (user_id, topic_id) VALUES('.$pun_user['id'].' ,'.$new_tid.')') or error('Impossible d\'ajouter l\'abonnement', __FILE__, __LINE__, $db->error());

				// Create the post ("topic post")
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id) VALUES(\''.$db->escape($username).'\', '.$pun_user['id'].', \''.get_remote_address().'\', \''.$db->escape($message).'\', \''.$hide_smilies.'\', '.$now.', '.$new_tid.')') or error('Impossible de créer le message', __FILE__, __LINE__, $db->error());
			}
			else
			{
				// Create the post ("topic post")
				$email_sql = ($pun_config['p_force_guest_email'] == '1' || $email != '') ? '\''.$email.'\'' : 'NULL';
				$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_ip, poster_email, message, hide_smilies, posted, topic_id) VALUES(\''.$db->escape($username).'\', \''.get_remote_address().'\', '.$email_sql.', \''.$db->escape($message).'\', \''.$hide_smilies.'\', '.$now.', '.$new_tid.')') or error('Impossible de créer le message', __FILE__, __LINE__, $db->error());
			}
			$new_pid = $db->insert_id();

			// Update the topic with last_post_id
			$db->query('UPDATE '.$db->prefix.'topics SET last_post_id='.$new_pid.' WHERE id='.$new_tid) or error('Impossible de modifier la discussion', __FILE__, __LINE__, $db->error());

			update_search_index('post', $new_pid, $message, $subject);

			update_forum($fid);
		}

		// If the posting user is logged in, increment his/her post count
		if (!$pun_user['is_guest'])
		{
			$low_prio = ($db_type == 'mysql') ? 'LOW_PRIORITY ' : '';
			$db->query('UPDATE '.$low_prio.$db->prefix.'users SET num_posts=num_posts+1, last_post='.$now.' WHERE id='.$pun_user['id']) or error('Impossible de modifier l\'utilisateur', __FILE__, __LINE__, $db->error());
		}

		redirect('viewtopic.php?pid='.$new_pid.'#p'.$new_pid, $lang_post['Post redirect']);
	}
}


// If a topic id was specified in the url (it's a reply).
if ($tid)
{
	$action = $lang_post['Post a reply'];
	$form = '<form id="post" method="post" action="post.php?action=post&amp;tid='.$tid.'" onsubmit="this.submit.disabled=true;if(process_form(this)){return true;}else{this.submit.disabled=false;return false;}">';

	// If a quote-id was specified in the url.
	if (isset($_GET['qid']))
	{
		$qid = intval($_GET['qid']);
		if ($qid < 1)
			message($lang_common['Bad request']);

		$result = $db->query('SELECT poster, message FROM '.$db->prefix.'posts WHERE id='.$qid.' AND topic_id='.$tid) or error('Impossible de retrouver les informations de citation', __FILE__, __LINE__, $db->error());
		if (!$db->num_rows($result))
			message($lang_common['Bad request']);

		list($q_poster, $q_message) = $db->fetch_row($result);

		$q_message = str_replace('[img]', '[url]', $q_message);
		$q_message = str_replace('[/img]', '[/url]', $q_message);
		$q_message = pun_htmlspecialchars($q_message);

		if ($pun_config['p_message_bbcode'] == '1')
		{
			// If username contains a square bracket, we add "" or '' around it (so we know when it starts and ends)
			if (strpos($q_poster, '[') !== false || strpos($q_poster, ']') !== false)
			{
				if (strpos($q_poster, '\'') !== false)
					$q_poster = '"'.$q_poster.'"';
				else
					$q_poster = '\''.$q_poster.'\'';
			}
			else
			{
				// Get the characters at the start and end of $q_poster
				$ends = substr($q_poster, 0, 1).substr($q_poster, -1, 1);

				// Deal with quoting "Username" or 'Username' (becomes '"Username"' or "'Username'")
				if ($ends == '\'\'')
					$q_poster = '"'.$q_poster.'"';
				else if ($ends == '""')
					$q_poster = '\''.$q_poster.'\'';
			}

			$quote = '[quote='.$q_poster.']'.$q_message.'[/quote]'."\n";
		}
		else
			$quote = '> '.$q_poster.' '.$lang_common['wrote'].':'."\n\n".'> '.$q_message."\n";
	}

	$forum_name = '<a href="viewforum.php?id='.$cur_posting['id'].'">'.pun_htmlspecialchars($cur_posting['forum_name']).'</a>';
}
// If a forum_id was specified in the url (new topic).
else if ($fid)
{
	$action = $lang_post['Post new topic'];
	$form = '<form id="post" method="post" action="post.php?action=post&amp;fid='.$fid.'" onsubmit="return process_form(this)">';

	$forum_name = pun_htmlspecialchars($cur_posting['forum_name']);
}
else
	message($lang_common['Bad request']);


$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$action;
$required_fields = array('req_email' => $lang_common['E-mail'], 'req_subject' => $lang_common['Subject'], 'req_message' => $lang_common['Message']);
$focus_element = array('post');

if (!$pun_user['is_guest'])
	$focus_element[] = ($fid) ? 'req_subject' : 'req_message';
else
{
	$required_fields['req_username'] = $lang_post['Guest name'];
	$focus_element[] = 'req_username';
}

/* <Mgs-01> - Repositionnement du sujet de la discussion sans le chemin d'acces (ajout) */
if (isset($cur_posting['subject'])) { 
$mgs_post = ' &gt; <strong>'.(pun_htmlspecialchars($cur_posting['subject'])).'</strong>'; 
} else {
$mgs_post = '';
}
$mgs_chemin = '<a href="index.php">'.($lang_common['Index']).'</a> &gt; '.$forum_name.$mgs_post;
/* </Mgs-01> */

require PUN_ROOT.'header.php';

?>

<?php 
/* <Mgs-02> - Inhibitin du code original (modif) */
/*
<div class="linkst">
	<div class="inbox">
		<ul><li><a href="index.php"><?php echo $lang_common['Index'] ?></a></li><li>&#160;&raquo;&#160;<?php echo $forum_name ?><?php if (isset($cur_posting['subject'])) echo '</li><li>&#160;&raquo;&#160;'.pun_htmlspecialchars($cur_posting['subject']) ?></li></ul>
	</div>
</div>
*/ 
/* </Mgs-02> */
?>

<?php

// If there are errors, we display them
if (!empty($errors))
{

?>
<div id="posterror" class="block">
	<h2><span><?php echo $lang_post['Post errors'] ?></span></h2>
	<div class="box">
		<div class="inbox">
			<p><?php echo $lang_post['Post errors info'] ?></p>
			<ul>
<?php

	while (list(, $cur_error) = each($errors))
		echo "\t\t\t\t".'<li><strong>'.$cur_error.'</strong></li>'."\n";
?>
			</ul>
		</div>
	</div>
</div>

<?php

}
else if (isset($_POST['preview']))
{
	/*********** Captcha Reponse ***********/
	if ($pun_user['is_guest']) {
		$cptchRepRes = cptchReponse();
		if ($cptchRepRes[0]) { message($cptchRepRes[1], $cptchRepRes[2]); }
	}
	/*********** Fin Captcha Reponse ***********/

	require_once PUN_ROOT.'include/parser.php';
	$preview_message = parse_message($message, $hide_smilies);

?>
<div id="postpreview" class="blockpost">
	<h2><span><?php echo $lang_post['Post preview'] ?></span></h2>
	<div class="box">
		<div class="inbox">
			<div class="postright">
				<div class="postmsg">
					<?php echo $preview_message."\n" ?>
				</div>
			</div>
		</div>
	</div>
</div>

<?php

}


$cur_index = 1;

?>
<div class="blockform">
	<h2><span><?php echo $action ?></span></h2>
	<div class="box">
		<?php echo $form."\n" ?>
			<div class="inform">
				<fieldset id="textform">
					<legend><?php echo $lang_common['Write message legend'] ?></legend>
					<div class="infldset txtarea">
						<input type="hidden" name="form_sent" value="1" />
						<input type="hidden" name="form_user" value="<?php echo (!$pun_user['is_guest']) ? pun_htmlspecialchars($pun_user['username']) : 'Invité'; ?>" />
<?php

if ($pun_user['is_guest'])
{
	// compteur_init(); // Initialisation du compteur
	$email_label = ($pun_config['p_force_guest_email'] == '1') ? '<strong>'.$lang_common['E-mail'].'</strong>' : $lang_common['E-mail'];
	$email_form_name = ($pun_config['p_force_guest_email'] == '1') ? 'req_email' : 'email';

?>						<label class="conl"><strong><?php echo $lang_post['Guest name'] ?></strong><br /><input type="text" name="req_username" value="<?php if (isset($_POST['req_username'])) echo pun_htmlspecialchars($username); ?>" size="25" maxlength="25" tabindex="<?php echo $cur_index++ ?>" /><br /></label>
						<label class="conl"><?php echo $email_label ?><br /><input type="text" name="<?php echo $email_form_name ?>" value="<?php if (isset($_POST[$email_form_name])) echo pun_htmlspecialchars($email); ?>" size="50" maxlength="50" tabindex="<?php echo $cur_index++ ?>" /><br /></label>
						<div class="clearer"></div>
<?php

}

if ($fid): ?>
						<label><strong><?php echo $lang_common['Subject'] ?></strong><br /><input class="longinput" type="text" name="req_subject" value="<?php if (isset($_POST['req_subject'])) echo pun_htmlspecialchars($subject); ?>" size="80" maxlength="70" tabindex="<?php echo $cur_index++ ?>" /><br /></label>
<?php endif; ?>						<label><strong><?php echo $lang_common['Message'] ?></strong><br />

<?php /* <Mgs-03> - Adaptation du code original et integration des emoticones et options cliquables (modif-ajout) */ ?>
						<textarea id="req_message" name="req_message" rows="25" cols="125" style="padding: 6px 8px 8px 8px; width: 640px;" tabindex="<?php echo $cur_index++ ?>"><?php echo isset($_POST['req_message']) ? pun_htmlspecialchars($message) : (isset($quote) ? $quote : ''); ?></textarea><br /></label>
						<script type="text/javascript" language="javascript">  
						<!--
						labelList = new Array("Veuillez noter l'adresse Url :", "Veuillez noter le texte de l'infobulle :", "Veuillez noter l'adresse E-mail :", "Veuillez noter le nom du style :", "Veuillez noter le nom de l'auteur :", "Veuillez noter l'adresse Url de l'image :", "Veuillez noter le nom ou le code de la couleur :");
						
						function text_sel() {
							var input = document.forms['post'].elements['req_message'];
							input.focus();
							if (typeof document.selection != 'undefined') { /* pour l'Explorer Internet */
								var range = document.selection.createRange();
								return range.text;
							} else if (typeof input.selectionStart != 'undefined') { /* pour navigateurs bases sur Gecko */
								var start = input.selectionStart;
								var end = input.selectionEnd;
								return input.value.substring(start, end);
							} else {
								return '';
							}
						}
						function insert_prompt(open, close, selOk, label1, label2) {
							if (selOk) { var textSel = text_sel(); } else { var textSel = ''; }
							if (label1 != null) {
								var attribut = prompt(labelList[label1], textSel);
								if (attribut != null && attribut != '') {
									open = open + '=' + attribut + ']';
								} else {
									if (label1 == 5 || label1 == 6) { return; }
									open = open + ']';
								}
							}
							if (label2 != null) {
								var infobulle = prompt(labelList[label2]);
								if (infobulle != null && infobulle != '') {
									close = '|' + infobulle + close;
								}
							}
							insert_text(open, close);
						}
						/* http://actuel.fr.selfhtml.org/articles/javascript/bbcode/index.htm */
						function insert_text(repdeb, repfin) {
							var input = document.forms['post'].elements['req_message'];
							input.focus();
							if (typeof document.selection != 'undefined') { /* pour l'Explorer Internet */
								/* Insertion du code de formatage */
								var range = document.selection.createRange();
								var insText = range.text;
								range.text = repdeb + insText + repfin;
								/* Ajustement de la position du curseur */
								range = document.selection.createRange();
								if (insText.length == 0) {
									if (repdeb.length == 0) {
										range.move('character', repfin.length);
									} else {
										range.move('character', -repfin.length);
									}
								} else {
									range.moveStart('character', repdeb.length + insText.length + repfin.length);
								}
								range.select();
							} else if (typeof input.selectionStart != 'undefined') { /* pour navigateurs bases sur Gecko */
								/* Insertion du code de formatage */
								var start = input.selectionStart;
								var end = input.selectionEnd;
								var insText = input.value.substring(start, end);
								input.value = input.value.substr(0, start) + repdeb + insText + repfin + input.value.substr(end);
								/* Ajustement de la position du curseur */
								var pos;
								if (insText.length == 0) {
									if (repdeb.length == 0) {
										pos = start + repfin.length;
									} else {
										pos = start + repdeb.length;
									}
								} else {
									pos = start + repdeb.length + insText.length + repfin.length;
								}
								input.selectionStart = pos;
								input.selectionEnd = pos;
							} else { /* pour les autres navigateurs */
								var pos = input.value.length;
								/* Insertion du code de formatage */
								var insText = prompt("Veuillez noter le texte à insérer :");
								input.value = input.value.substr(0, pos) + repdeb + insText + repfin + input.value.substr(pos);
							}
						}
						// -->
						</script>
						<div style="margin: 4px 0px; padding: 2px 8px 4px 8px; width: 622px; border: 1px solid silver; background-color: #f9f9f9">
							<div style="margin: 2px 0px 6px 0px;">
								<strong>&Eacute;motic&ocirc;nes&nbsp;:&nbsp; </strong>  
								<a href="#textform" onclick="insert_text('', ' :) '); return false"><img border="0" src="img/smilies/smile.png" width="15" height="15" alt=":)" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :| '); return false"><img border="0" src="img/smilies/neutral.png" width="15" height="15" alt=":|" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :( '); return false"><img border="0" src="img/smilies/sad.png" width="15" height="15" alt=":(" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :D '); return false"><img border="0" src="img/smilies/big_smile.png" width="15" height="15" alt=":D" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :o '); return false"><img border="0" src="img/smilies/yikes.png" width="15" height="15" alt=":o" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' ;) '); return false"><img border="0" src="img/smilies/wink.png" width="15" height="15" alt=";)" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :/ '); return false"><img border="0" src="img/smilies/hmm.png" width="15" height="15" alt=":/" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :P '); return false"><img border="0" src="img/smilies/tongue.png" width="15" height="15" alt=":P" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :lol: '); return false"><img border="0" src="img/smilies/lol.png" width="15" height="15" alt=":lol:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :mad: '); return false"><img border="0" src="img/smilies/mad.png" width="15" height="15" alt=":mad:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :rolleyes: '); return false"><img border="0" src="img/smilies/roll.png" width="15" height="15" alt=":rolleyes:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :cool: '); return false"><img border="0" src="img/smilies/cool.png" width="15" height="15" alt=":cool:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :blink: '); return false"><img border="0" src="img/smilies/blink.gif" width="15" height="15" alt=":blink:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :cheese: '); return false"><img border="0" src="img/smilies/cheese.gif" width="15" height="15" alt=":cheese:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :huh: '); return false"><img border="0" src="img/smilies/huh.gif" width="15" height="15" alt=":huh:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :mdr: '); return false"><img border="0" src="img/smilies/mdr.gif" width="15" height="15" alt=":mdr:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :not: '); return false"><img border="0" src="img/smilies/non.gif" width="15" height="15" alt=":non:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :yes: '); return false"><img border="0" src="img/smilies/oui.gif" width="15" height="15" alt=":ok:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :pleure: '); return false"><img border="0" src="img/smilies/pleure.gif" width="17" height="15" alt=":pleure:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :siffle: '); return false"><img border="0" src="img/smilies/siffle.gif" width="25" height="15" alt=":siffle:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :top: '); return false"><img border="0" src="img/smilies/top.gif" width="17" height="20" alt=":top:" /></a>&nbsp;
								<a href="#textform" onclick="insert_text('', ' :unsure: '); return false"><img border="0" src="img/smilies/unsure.gif" width="15" height="15" alt=":unsure:" /></a>&nbsp;
							</div>
							<div style="margin: 6px 0px;">
								<strong>Style du texte&nbsp;:&nbsp; </strong>  
								<a href="#textform" onclick="insert_text('[b]','[/b]'); return false"><strong>Gras</strong></a>&nbsp;
								<a href="#textform" onclick="insert_text('[i]','[/i]'); return false"><em>Italique</em></a>&nbsp;
								<a href="#textform" onclick="insert_text('[u]','[/u]'); return false"><ins>Soulign&eacute;</ins></a>&nbsp;
								<a href="#textform" onclick="insert_text('[s]','[/s]'); return false"><del>Barr&eacute;</del></a>&nbsp;
								|&nbsp;
								<a href="#textform" onclick="insert_text('[color=red]','[/color]'); return false"><span style="color: red">Rouge</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=green]','[/color]'); return false"><span style="color: green">Vert</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=blue]','[/color]'); return false"><span style="color: blue">Bleu</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=maroon]','[/color]'); return false"><span style="color: maroon">Marron</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=orange]','[/color]'); return false"><span style="color: orange">Orange</span></a>&nbsp;
								<a href="#textform" onclick="insert_text('[color=navy]','[/color]'); return false"><span style="color: navy">Marine</span></a>&nbsp;- 
								<a href="#textform" onclick="insert_prompt('[color','[/color]',false,6,null); return false"><span style="color: black">Autre</span></a>&nbsp;
							</div>
							<div style="margin: 6px 0px;">
								<strong>Liens et blocs&nbsp;:&nbsp; </strong>  
								<a href="#textform" onclick="insert_prompt('[url','[/url]',true,0,1); return false">Lien Url</a>&nbsp;
								<a href="#textform" onclick="insert_prompt('[email','[/email]',true,2,1); return false">Lien Email</a>&nbsp;
								<a href="#textform" onclick="insert_text('[img]','[/img]'); return false">Lien Image</a>&nbsp;
								|&nbsp;
								<a href="#textform" onclick="insert_prompt('[quote','[/quote]',false,4,null); return false">Bloc Citation</a>&nbsp;
								<a href="#textform" onclick="insert_text('[code]','[/code]'); return false">Bloc Code</a>&nbsp;
								<a href="#textform" onclick="insert_prompt('[edit','[/edit]',false,4,null); return false">Bloc Edit</a>&nbsp;
								|&nbsp;
								<a href="#textform" onclick="insert_text('[center]','[/center]'); return false">Centrer</a>&nbsp;
								<a href="#textform" onclick="insert_text('',' [hr] '); return false">Filet</a>&nbsp;
							</div>
						</div>
<?php /* </Mgs-03> */ ?>
						<ul class="bblinks">
							<li><a href="help.php#bbcode" onclick="window.open(this.href); return false;"><?php echo $lang_common['BBCode'] ?></a>: <?php echo ($pun_config['p_message_bbcode'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#img" onclick="window.open(this.href); return false;"><?php echo $lang_common['img tag'] ?></a>: <?php echo ($pun_config['p_message_img_tag'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#smilies" onclick="window.open(this.href); return false;"><?php echo $lang_common['Smilies'] ?></a>: <?php echo ($pun_config['o_smilies'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
						</ul>
					</div>
				</fieldset>
<?php

$checkboxes = array();
if (!$pun_user['is_guest'])
{
	if ($pun_config['o_smilies'] == '1')
		$checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="'.($cur_index++).'"'.(isset($_POST['hide_smilies']) ? ' checked="checked"' : '').' />'.$lang_post['Hide smilies'];

	if ($pun_config['o_subscriptions'] == '1')
		$checkboxes[] = '<label><input type="checkbox" name="subscribe" value="1" tabindex="'.($cur_index++).'"'.(isset($_POST['subscribe']) ? ' checked="checked"' : '').' />'.$lang_post['Subscribe'];
}
else if ($pun_config['o_smilies'] == '1')
	$checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="'.($cur_index++).'"'.(isset($_POST['hide_smilies']) ? ' checked="checked"' : '').' />'.$lang_post['Hide smilies'];
?>
			</div>
			<div class="inform" style="overflow: hidden;">			
<?php
/*********** Captcha Question ***********/
if ($pun_user['is_guest']) {
	$cptchQstRes = cptchQuestion();	
?>
				<fieldset style="margin: 0px; width: 46%; float: left;">
					<legend>S&eacute;curit&eacute;</legend>
					<div class="infldset" style="padding: 4px 4px 5px 4px;">
						<p>Veuillez noter le r&eacute;sultat de l'op&eacute;ration suivante :</p>
						<p><label><strong><?php echo $cptchQstRes[0] ?></strong>
						<input name="captcha" id="captcha" type="text" size="5" maxlength="10" style="text-align: center;"/>
						<input name="captcha_q" value="<?php echo $cptchQstRes[1] ?>" type="hidden" />
						<br /></label></p>
					</div>
				</fieldset>
<?php
}
/*********** Fin Captcha Question ***********/

if (!empty($checkboxes))
{
?>
				<fieldset<?php if ($pun_user['is_guest']) { echo ' style="margin: 0px; width: 46%; float: right;"'; } ?>>
					<legend><?php echo $lang_common['Options'] ?></legend>
					<div class="infldset">
						<div class="rbox">
							<?php echo implode('<br /></label>'."\n\t\t\t\t", $checkboxes).'<br /></label>'."\n" ?>
						</div>
					</div>
				</fieldset>
<?php
}
?>
			</div>
		<div>
			<fieldset>
			<legend>Validation</legend>
			<div class="infldset" style="text-align: center; padding: 2px 2px 6px 2px;">
			<p><input type="submit" name="submit" value="&nbsp;&nbsp;<?php echo $lang_common['Submit'] ?>&nbsp;&nbsp;" tabindex="<?php echo $cur_index++ ?>" accesskey="s" /><input type="submit" name="preview" value="&nbsp;&nbsp;<?php echo $lang_post['Preview'] ?>&nbsp;&nbsp;" tabindex="<?php echo $cur_index++ ?>" accesskey="p" /><a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a></p>
			</div>
			</fieldset>
		</div>
		</form>
	</div>
</div>

<?php

// Check to see if the topic review is to be displayed.
if ($tid && $pun_config['o_topic_review'] != '0')
{
	require_once PUN_ROOT.'include/parser.php';

	$result = $db->query('SELECT poster, message, hide_smilies, posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id DESC LIMIT '.$pun_config['o_topic_review']) or error('Impossible de retrouver le résumé de la discussion', __FILE__, __LINE__, $db->error());

?>

<div id="postreview" class="blockpost">
	<h2><span><?php echo $lang_post['Topic review'] ?></span></h2>
<?php

	//Set background switching on
	$bg_switch = true;
	$post_count = 0;

	while ($cur_post = $db->fetch_assoc($result))
	{
		// Switch the background color for every message.
		$bg_switch = ($bg_switch) ? $bg_switch = false : $bg_switch = true;
		$vtbg = ($bg_switch) ? ' roweven' : ' rowodd';
		$post_count++;

		$cur_post['message'] = parse_message($cur_post['message'], $cur_post['hide_smilies']);

?>
	<div class="box<?php echo $vtbg ?>">
		<div class="inbox">
			<div class="postleft">
				<dl>
					<dt><strong><?php echo pun_htmlspecialchars($cur_post['poster']) ?></strong></dt>
					<dd><?php echo format_time($cur_post['posted']) ?></dd>
				</dl>
			</div>
			<div class="postright">
				<div class="postmsg">
					<?php echo $cur_post['message'] ?>
				</div>
			</div>
			<div class="clearer"></div>
		</div>
	</div>
<?php

	}

?>
</div>
<?php

}

require PUN_ROOT.'footer.php';